︠5d2261bb-0859-4ca3-b2da-968d60c7d2af︠
def trace_algo(cmd):
    sort_gen = iter(cmd)
    def bla(cmd=selector(["Step"], 
                       buttons=True)):
        global dessin
        try:
            mess, dessin = sort_gen.next()
        except StopIteration:
            mess = "======== Fin ======="
        print mess
        dessin.show()
    return (bla)
︡de68f00b-1cce-493b-9e46-eea68e3b1d2c︡︡
︠10a3f54e-ff3c-44a4-abc1-985248ec4c42︠
def plot_tab(tab):
    return sum(point(v, size=50) for v in
                enumerate(tab))
︡5a74841e-77c4-46de-9268-9401be82015c︡︡
︠7ce77ce9-af26-4d95-a10e-f56a7b791142︠
def vert(i, tab, color="red"):
    return line([(i, 0),(i, max(tab))], color=color)
︡d87b41ce-864e-4ecb-8e48-441cb31ff684︡︡
︠447148f8-9907-4889-bd17-25ae9e9e1df8︠
def horiz(i, tab, color="green"):
    return line([(0,i),(len(tab),i)], color=color)
︡c301b080-ea31-4457-afdd-bced50416e1f︡︡
︠dd600ff4-184c-401f-81bd-1b3c24573726i︠
%html
<h1 style="text-align: center;"><strong>Bubble Sort</strong></h1>

︡7c1cf5b1-3197-41f3-b16a-aef9fde4837b︡{"html": "<h1 style=\"text-align: center;\"><strong>Bubble Sort</strong></h1>"}︡
︠824a4771-8fd7-467c-b9c1-9d847ac19af0︠
def bubble_sort(T):
    def dessin():
        return ("i=%i, j=%i"%(i,j), plot_tab(T)+
                     vert(i,tab)+vert(j+1/2,tab))
    yield "Start", plot_tab(T)
    for i in range(len(T)-1, 0, -1):
        for j in range(i):
            if T[j] > T[j+1]:
                T[j], T[j+1] = T[j+1], T[j]  
            yield dessin()
︡818791e4-6bcd-4736-a13e-90c67b89ac2c︡︡
︠59971290-f89d-4224-9101-708726a43e48︠
tab = [randint(0, 20) for i in range(10)]
interact(trace_algo(bubble_sort(tab)))
︡c12c80bf-b9d7-4b02-8837-69cc4fdb818c︡︡
︠0c686d2c-8933-43b6-882f-1f361aa6b4c9i︠
%html
<h1 style="text-align: center;"><strong>Insert Sort</strong></h1>
<p><strong><br /></strong></p>

︡5a74da61-af63-46a3-ba2e-e54b784a07c3︡{"html": "<h1 style=\"text-align: center;\"><strong>Insert Sort</strong></h1>\n<p><strong><br /></strong></p>"}︡
︠75101ee9-1f8c-4354-88db-31f11d98ac61︠
def insert_sort(T):
    def dessin():
        return ("i=%i, j=%i, e=%i"%(i,j,e), 
            plot_tab(T)+vert(j, tab)+horiz(e, tab))
    yield "Start", plot_tab(T)
    for i in range(1,len(T)):
        e = T[i]
        j = i
        yield dessin()
        while j>0 and T[j-1] > e:
            T[j] = T[j-1]
            j -= 1
            yield dessin()
        T[j] = e
        yield dessin()
︡d854c7f1-7315-4425-8ce8-30ef66abc627︡︡
︠8a783668-58f2-4039-8459-1c3b7dcd369d︠
tab = [randint(0, 20) for i in range(10)]
interact(trace_algo(insert_sort(tab)))
︡6831ffe7-ab04-46d2-968d-1fd6ea1f78d7︡︡
︠2b68bfc3-a6cf-44d8-be1b-dddc051bee73i︠
%html
<h1 style="text-align: center;"><strong>Partitioning</strong></h1>

<h2>Left to right method</h2>

︡b6618d3e-5157-438a-b2d2-e328d55bdb63︡{"html": "<h1 style=\"text-align: center;\"><strong>Partitioning</strong></h1>\n\n<h2>Left to right method</h2>"}︡
︠5d3e5c8e-c972-4c88-be98-54127beb65d0︠
def partition(Tab, P):
    c = 0; j = 0    
    def dessin():
        return (sum(point((i,v), size=40, 
                   color="green" if P(v) else "red") 
            for i,v in enumerate(tab)) 
            + vert(c, Tab, "green") + vert(j, Tab))
    yield "Start", dessin()
    c = 0
    while c < len(Tab) and P(Tab[c]):
        c +=1
    yield "c=%i"%c, dessin()+vert(c, Tab, "green")
    for j in range(c+1, len(Tab)):
        yield ("c=%i, j=%i"%(c, j), dessin())
        if P(Tab[j]):
            Tab[c], Tab[j] = Tab[j], Tab[c]
            c +=1        
            yield ("c=%i, j=%i"%(c, j), dessin())

    yield ("Retour %i"%c, 
        dessin()+vert(c-1/2, Tab, "blue"))
︡5824e049-e672-4c05-b7c7-ba1edc9859de︡︡
︠51a6e85c-6e73-4033-8263-27609ea602f1︠
tab = [randint(0, 20) for i in range(20)]
interact(trace_algo(partition(tab, 
                      lambda x: x % 2 == 0)))
︡b7debba9-fe6a-4423-ab1a-ef0b60f34c92︡{"html": "<!--notruncate-->\n        <div padding=6 id=\"div-interact-8\">\n          <table width=800px height=20px bgcolor=\"#c5c5c5\" cellpadding=15>\n            <tr>\n              <td bgcolor=\"#f9f9f9\" valign=top align=left>\n            <table>\n              <tr><td colspan=3><table><tr><td align=right><font color=\"black\">cmd&nbsp;</font></td><td><table style=\"border:1px solid #dfdfdf; background-color:#efefef;\">\n<tr><td><button style=\"border-style:outset;\" value=\"0\" onclick=\"interact(8, {variable: 'cmd', adapt_number: 3, value: encode64(this.value)}, 1)\">Step</button>\n</td></tr></table></td>\n</tr></table></td></tr>\n              <tr><td></td><td style='width: 100%;'>\n        <div id=\"cell-interact-8\"><?__SAGE__START>\n          <table border=0 bgcolor=\"white\" width=100%>\n            <tr>\n              <td bgcolor=\"white\" align=left valign=top>\n                <pre><?__SAGE__TEXT></pre>\n              </td>\n            </tr>\n            <tr>\n              <td align=left valign=top><?__SAGE__HTML></td>\n            </tr>\n          </table><?__SAGE__END>\n        </div></td><td></td></tr>\n              <tr><td colspan=3></td></tr>\n            </table></td>\n            </tr>\n          </table>\n        </div>"}︡{"stdout": "<function bla at 0x570bd70>"}︡
︠7c1b6938-d0dc-4e08-ab79-765af4c89cf1i︠
%html
<h2>Double sided method</h2>

︡41973ebd-5efe-4b0a-a523-84d471a1867e︡{"html": "<h2>Double sided method</h2>"}︡
︠250b2b39-bb1a-4ae9-8938-90eb22381d34︠
def partition2(Tab, P): 
    def dessin():
        return (sum(point((i,v), size=40, 
                   color="green" if P(v) else "red") 
            for i,v in enumerate(tab)) 
            + vert(i, Tab, "green") + vert(j, Tab))
            
    i = 0
    j = len(Tab)-1
    yield         "Start", dessin()
    while i < j:
        while P(Tab[i]): i += 1
        while not P(Tab[j]): j -= 1
        yield      "i=%i, j=%i"%(i, j), dessin()
        if i<j:
            Tab[i], Tab[j] = Tab[j], Tab[i]
            yield "i=%i, j=%i"%(i, j), dessin()
            i += 1; j -= 1
    yield         ("Retour %i"%(i-1), 
            dessin() + vert(i-1/2, Tab, "blue"))
︡a98c6217-8342-4dd5-a2ba-4abab51dea8a︡︡
︠5ef40bcf-f166-4799-bd13-08340b6bbfbe︠
tab = [randint(0, 20) for i in range(20)]
interact(trace_algo(partition2(tab, 
                      lambda x: x % 2 == 0)))
︡a67b7b25-9d76-4c57-8132-0a4b4d87facd︡{"html": "<!--notruncate-->\n        <div padding=6 id=\"div-interact-11\">\n          <table width=800px height=20px bgcolor=\"#c5c5c5\" cellpadding=15>\n            <tr>\n              <td bgcolor=\"#f9f9f9\" valign=top align=left>\n            <table>\n              <tr><td colspan=3><table><tr><td align=right><font color=\"black\">cmd&nbsp;</font></td><td><table style=\"border:1px solid #dfdfdf; background-color:#efefef;\">\n<tr><td><button style=\"border-style:outset;\" value=\"0\" onclick=\"interact(11, {variable: 'cmd', adapt_number: 4, value: encode64(this.value)}, 1)\">Step</button>\n</td></tr></table></td>\n</tr></table></td></tr>\n              <tr><td></td><td style='width: 100%;'>\n        <div id=\"cell-interact-11\"><?__SAGE__START>\n          <table border=0 bgcolor=\"white\" width=100%>\n            <tr>\n              <td bgcolor=\"white\" align=left valign=top>\n                <pre><?__SAGE__TEXT></pre>\n              </td>\n            </tr>\n            <tr>\n              <td align=left valign=top><?__SAGE__HTML></td>\n            </tr>\n          </table><?__SAGE__END>\n        </div></td><td></td></tr>\n              <tr><td colspan=3></td></tr>\n            </table></td>\n            </tr>\n          </table>\n        </div>"}︡{"stdout": "<function bla at 0x6498a28>"}︡
